#
# Conditional build:
%bcond_without	python2 # Python 2.x module
%bcond_without	python3 # Python 3.x module
%bcond_without	doc	# Sphinx documentation
%bcond_without	tests	# unit tests

Summary:	A comprehensive HTTP client library
Summary(pl.UTF-8):	Obszerna biblioteka klienta HTTP
Name:		python-httplib2
Version:	0.22.0
Release:	1
License:	MIT
Group:		Development/Languages/Python
#Source0Download: https://github.com/httplib2/httplib2/releases
Source0:	https://github.com/httplib2/httplib2/archive/v%{version}/httplib2-%{version}.tar.gz
# Source0-md5:	e1ea1cd44c908a78112b6007af0f5917
Patch0:		%{name}.certfile.patch
Patch1:		%{name}-0.9-proxy-http.patch
URL:		https://github.com/httplib2/httplib2
%if %{with python2}
BuildRequires:	python-modules >= 1:2.7
BuildRequires:	python-setuptools
%if %{with tests}
BuildRequires:	python-future >= 0.16.0
BuildRequires:	python-mock >= 2.0.0
BuildRequires:	python-pyparsing >= 2.4.2
BuildRequires:	python-pyparsing < 3
BuildRequires:	python-pytest >= 4.6.11
BuildRequires:	python-pytest-cov >= 2.5.1
BuildRequires:	python-pytest-forked >= 1.3.0
# >= 2.12.1
BuildRequires:	python-pytest-randomly >= 1.2.3
BuildRequires:	python-pytest-timeout >= 1.4.2
BuildRequires:	python-six >= 1.10.0
%endif
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.4
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-pyparsing >= 2.4.2
BuildRequires:	python3-pyparsing < 4
BuildRequires:	python3-pytest >= 6.1.2
BuildRequires:	python3-pytest-cov >= 2.5.1
# >= 2.12.1
BuildRequires:	python3-pytest-forked >= 1.3.0
BuildRequires:	python3-pytest-randomly >= 1.2.3
BuildRequires:	python3-pytest-timeout >= 1.4.2
BuildRequires:	python3-six >= 1.10.0
%endif
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.710
%if %{with doc}
BuildRequires:	sphinx-pdg
%endif
Requires:	ca-certificates
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
A comprehensive HTTP client library, httplib2.py supports many
features left out of other HTTP libraries. Supports:
- HTTP and HTTPS
- Keep-Alive
- Authentication
- Caching
- All Methods
- Redirects
- Compression
- Lost update support
- Unit Tested

%description -l pl.UTF-8
httplib2.py to obszerna biblioteka klienta HTTP, obsługująca wiele
cech pomijanych przez inne biblioteki. Obsługuje:
- HTTP i HTTPS
- Keep-Alive
- uwierzytelnianie
- buforowanie
- wszystkie metody
- przekierowania
- kompresję
- Lost update
- podlega testom jednostkowym.

%package -n python3-httplib2
Summary:	A comprehensive HTTP client library
Summary(pl.UTF-8):	Obszerna biblioteka klienta HTTP
Group:		Development/Languages/Python
Requires:	ca-certificates

%description -n python3-httplib2
A comprehensive HTTP client library, httplib2.py supports many
features left out of other HTTP libraries. Supports:
- HTTP and HTTPS
- Keep-Alive
- Authentication
- Caching
- All Methods
- Redirects
- Compression
- Lost update support
- Unit Tested

%description -n python3-httplib2 -l pl.UTF-8
httplib2.py to obszerna biblioteka klienta HTTP, obsługująca wiele
cech pomijanych przez inne biblioteki. Obsługuje:
- HTTP i HTTPS
- Keep-Alive
- uwierzytelnianie
- buforowanie
- wszystkie metody
- przekierowania
- kompresję
- Lost update
- podlega testom jednostkowym.

%prep
%setup -q -n httplib2-%{version}
%patch0 -p1
%patch1 -p1

%build
%if %{with python2}
%py_build

%if %{with tests}
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS=pytest_cov.plugin,pytest_timeout \
PYTHONPATH=$(pwd)/build-2/lib \
%{__python} -m pytest tests -k 'not test_certs_file_from_builtin and not test_certs_file_from_environment and not test_ipv6 and not test_with_certifi_removed_from_modules and not test_noproxy_star'
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
# in python3 implementation system socks module is preferred over httplib2.socks, and the first is incompatible with test_socks5_auth
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
PYTEST_PLUGINS=pytest_cov.plugin,pytest_timeout \
PYTHONPATH=$(pwd)/build-3/lib \
%{__python3} -m pytest tests -k 'not test_certs_file_from_builtin and not test_certs_file_from_environment and not test_ipv6 and not test_with_certifi_removed_from_modules and not test_noproxy_star and not test_server_not_found_error_is_raised_for_invalid_hostname and not test_socks5_auth'
%endif
%endif

%if %{with doc}
%{__make} -C doc html
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean
%{__rm} $RPM_BUILD_ROOT%{py_sitescriptdir}/httplib2/cacerts.txt
%endif

%if %{with python3}
%py3_install

%{__rm} $RPM_BUILD_ROOT%{py3_sitescriptdir}/httplib2/cacerts.txt
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc CHANGELOG LICENSE README.md
%{py_sitescriptdir}/httplib2
%{py_sitescriptdir}/httplib2-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-httplib2
%defattr(644,root,root,755)
%doc CHANGELOG LICENSE README.md python3/README
%{py3_sitescriptdir}/httplib2
%{py3_sitescriptdir}/httplib2-%{version}-py*.egg-info
%endif
%changelog
* Tue Sep 19 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-httplib2.git;a=log;h=master

* Mon Sep 18 2023 Jakub Bogusz <qboosh@pld-linux.org> 34e02e2
- updated to 0.22.0

* Thu Apr 28 2022 Jakub Bogusz <qboosh@pld-linux.org> 16d55c0
- updated to 0.20.4

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> af4b192
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 80f5448
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 632ae02
- rebuild with python 3.10

* Thu Mar 04 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> 78549cb
- release 2 (by relup.sh)

* Thu Mar 04 2021 Arkadiusz Miśkiewicz <arekm@maven.pl> db87bd5
- rediff patches

* Sun Jun 07 2020 Jakub Bogusz <qboosh@pld-linux.org> 2ec8bbf
- disable test_ipv6 (seems to require network)

* Sun Jun 07 2020 Jakub Bogusz <qboosh@pld-linux.org> 408d990
- updated to 0.18.1 (CRLF injection fix)

* Thu Apr 02 2020 Jakub Bogusz <qboosh@pld-linux.org> ebcdddb
- added mock patch (prefer unittest.mock from stdlib on python3)
- added tests and doc, updated dependencies

* Sat Feb 08 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 8625bb3
- up to 0.17.0

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> c8b8447
- rebuild with python 3.8
- release 2 (by relup.sh)

* Thu Mar 14 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> 22322f8
- up to 0.12.1

* Fri Nov 16 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> b9a87db
- up to 0.12.0

* Sun Jul 01 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> af2d1f4
- release 2 (by relup.sh)

* Wed Apr 11 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> b43c14c
- up to 0.11.3

* Tue Feb 27 2018 Arkadiusz Miśkiewicz <arekm@maven.pl> 5007a43
- up to 0.10.3; use system ca-bundle; patches from FC

* Thu Dec 29 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 0a0cad5
- python 3.6
- release 6 (by relup.sh)

* Sun Nov 29 2015 Elan Ruusamäe <glen@delfi.ee> a0736ae
- rpm build macros for %{py,py3}_{build,install}

* Sat Nov 28 2015 Jacek Konieczny <jajcus@jajcus.net> 63e7c74
- release 5 (by relup.sh)

